diff --git a/examples/kprobe_open.py b/examples/kprobe_open.py
index f8d4d8b..43b4212 100755
--- a/examples/kprobe_open.py
+++ b/examples/kprobe_open.py
@@ -3,7 +3,7 @@
 """
 SPDX-License-Identifier: CC-BY-4.0
 
-Copyright (C) 2021 VMware Inc, Yordan Karadzhov (VMware) <y.karadz@gmail.com>
+Copyright 2021 VMware Inc, Yordan Karadzhov (VMware) <y.karadz@gmail.com>
 """
 
 import sys
diff --git a/examples/start_tracing.py b/examples/start_tracing.py
index da36164..c9960e3 100755
--- a/examples/start_tracing.py
+++ b/examples/start_tracing.py
@@ -3,7 +3,7 @@
 """
 SPDX-License-Identifier: CC-BY-4.0
 
-Copyright (C) 2021 VMware Inc, Yordan Karadzhov (VMware) <y.karadz@gmail.com>
+Copyright 2021 VMware Inc, Yordan Karadzhov (VMware) <y.karadz@gmail.com>
 """
 
 import tracecruncher.ftracepy as ft
diff --git a/src/common.h b/src/common.h
index 476e4f1..abfda1f 100644
--- a/src/common.h
+++ b/src/common.h
@@ -1,7 +1,7 @@
 /* SPDX-License-Identifier: LGPL-2.1 */
 
 /*
- * Copyright (C) 2017 VMware Inc, Yordan Karadzhov <y.karadz@gmail.com>
+ * Copyright 2017 VMware Inc, Yordan Karadzhov <y.karadz@gmail.com>
  */
 
 #ifndef _TC_COMMON_H
diff --git a/src/ftracepy-utils.c b/src/ftracepy-utils.c
index 8e0ca42..53fc95f 100644
--- a/src/ftracepy-utils.c
+++ b/src/ftracepy-utils.c
@@ -1,7 +1,7 @@
 // SPDX-License-Identifier: LGPL-2.1
 
 /*
- * Copyright (C) 2021 VMware Inc, Yordan Karadzhov (VMware) <y.karadz@gmail.com>
+ * Copyright 2021 VMware Inc, Yordan Karadzhov (VMware) <y.karadz@gmail.com>
  */
 
 #ifndef _GNU_SOURCE
diff --git a/src/ftracepy-utils.h b/src/ftracepy-utils.h
index 26a2f14..218dcb3 100644
--- a/src/ftracepy-utils.h
+++ b/src/ftracepy-utils.h
@@ -1,7 +1,7 @@
 /* SPDX-License-Identifier: LGPL-2.1 */
 
 /*
- * Copyright (C) 2021 VMware Inc, Yordan Karadzhov <y.karadz@gmail.com>
+ * Copyright 2021 VMware Inc, Yordan Karadzhov <y.karadz@gmail.com>
  */
 
 #ifndef _TC_FTRACE_PY_UTILS
diff --git a/src/ftracepy.c b/src/ftracepy.c
index e5a91fc..f03c488 100644
--- a/src/ftracepy.c
+++ b/src/ftracepy.c
@@ -1,7 +1,7 @@
 // SPDX-License-Identifier: LGPL-2.1
 
 /*
- * Copyright (C) 2021 VMware Inc, Yordan Karadzhov (VMware) <y.karadz@gmail.com>
+ * Copyright 2021 VMware Inc, Yordan Karadzhov (VMware) <y.karadz@gmail.com>
  */
 
 // trace-cruncher
diff --git a/src/ksharkpy-utils.c b/src/ksharkpy-utils.c
index 12972fb..5744a44 100644
--- a/src/ksharkpy-utils.c
+++ b/src/ksharkpy-utils.c
@@ -1,7 +1,7 @@
 // SPDX-License-Identifier: LGPL-2.1
 
 /*
- * Copyright (C) 2021 VMware Inc, Yordan Karadzhov (VMware) <y.karadz@gmail.com>
+ * Copyright 2021 VMware Inc, Yordan Karadzhov (VMware) <y.karadz@gmail.com>
  */
 
 #ifndef _GNU_SOURCE
diff --git a/src/ksharkpy-utils.h b/src/ksharkpy-utils.h
index 6d17d2e..0f11c80 100644
--- a/src/ksharkpy-utils.h
+++ b/src/ksharkpy-utils.h
@@ -1,7 +1,7 @@
 /* SPDX-License-Identifier: LGPL-2.1 */
 
 /*
- * Copyright (C) 2021 VMware Inc, Yordan Karadzhov <y.karadz@gmail.com>
+ * Copyright 2021 VMware Inc, Yordan Karadzhov <y.karadz@gmail.com>
  */
 
 #ifndef _TC_KSHARK_PY_UTILS
diff --git a/src/ksharkpy.c b/src/ksharkpy.c
index 7cfb94b..af49c86 100644
--- a/src/ksharkpy.c
+++ b/src/ksharkpy.c
@@ -1,7 +1,7 @@
 // SPDX-License-Identifier: LGPL-2.1
 
 /*
- * Copyright (C) 2019 VMware Inc, Yordan Karadzhov (VMware) <y.karadz@gmail.com>
+ * Copyright 2019 VMware Inc, Yordan Karadzhov (VMware) <y.karadz@gmail.com>
  */
 
 /** Use GNU C Library. */
diff --git a/tests/0_get_data/test_get_data.py b/tests/0_get_data/test_get_data.py
index 53decd0..008641e 100755
--- a/tests/0_get_data/test_get_data.py
+++ b/tests/0_get_data/test_get_data.py
@@ -3,7 +3,7 @@
 """
 SPDX-License-Identifier: LGPL-2.1
 
-Copyright (C) 2021 VMware Inc, Yordan Karadzhov (VMware) <y.karadz@gmail.com>
+Copyright 2021 VMware Inc, Yordan Karadzhov (VMware) <y.karadz@gmail.com>
 """
 
 import os
diff --git a/tests/1_unit/test_01_ftracepy_unit.py b/tests/1_unit/test_01_ftracepy_unit.py
index 3411b3f..971fd5f 100644
--- a/tests/1_unit/test_01_ftracepy_unit.py
+++ b/tests/1_unit/test_01_ftracepy_unit.py
@@ -3,7 +3,7 @@
 """
 SPDX-License-Identifier: LGPL-2.1
 
-Copyright (C) 2021 VMware Inc, Yordan Karadzhov (VMware) <y.karadz@gmail.com>
+Copyright 2021 VMware Inc, Yordan Karadzhov (VMware) <y.karadz@gmail.com>
 """
 
 import os
diff --git a/tests/1_unit/test_02_datawrapper_unit.py b/tests/1_unit/test_02_datawrapper_unit.py
index 58c8706..0272d3c 100755
--- a/tests/1_unit/test_02_datawrapper_unit.py
+++ b/tests/1_unit/test_02_datawrapper_unit.py
@@ -3,7 +3,7 @@
 """
 SPDX-License-Identifier: LGPL-2.1
 
-Copyright (C) 2021 VMware Inc, Yordan Karadzhov (VMware) <y.karadz@gmail.com>
+Copyright 2021 VMware Inc, Yordan Karadzhov (VMware) <y.karadz@gmail.com>
 """
 
 import os
diff --git a/tests/1_unit/test_03_ksharkpy_unit.py b/tests/1_unit/test_03_ksharkpy_unit.py
index c7da2a1..20e3cf5 100755
--- a/tests/1_unit/test_03_ksharkpy_unit.py
+++ b/tests/1_unit/test_03_ksharkpy_unit.py
@@ -3,7 +3,7 @@
 """
 SPDX-License-Identifier: LGPL-2.1
 
-Copyright (C) 2021 VMware Inc, Yordan Karadzhov (VMware) <y.karadz@gmail.com>
+Copyright 2021 VMware Inc, Yordan Karadzhov (VMware) <y.karadz@gmail.com>
 """
 
 import os
diff --git a/tests/2_integration/test_01_ftracepy_integration.py b/tests/2_integration/test_01_ftracepy_integration.py
index 824decd..1db5f0b 100755
--- a/tests/2_integration/test_01_ftracepy_integration.py
+++ b/tests/2_integration/test_01_ftracepy_integration.py
@@ -3,7 +3,7 @@
 """
 SPDX-License-Identifier: LGPL-2.1
 
-Copyright (C) 2021 VMware Inc, Yordan Karadzhov (VMware) <y.karadz@gmail.com>
+Copyright 2021 VMware Inc, Yordan Karadzhov (VMware) <y.karadz@gmail.com>
 """
 
 import os
diff --git a/tests/2_integration/test_03_ksharkpy_integration.py b/tests/2_integration/test_03_ksharkpy_integration.py
index dd8e0b5..7515342 100755
--- a/tests/2_integration/test_03_ksharkpy_integration.py
+++ b/tests/2_integration/test_03_ksharkpy_integration.py
@@ -3,7 +3,7 @@
 """
 SPDX-License-Identifier: LGPL-2.1
 
-Copyright (C) 2021 VMware Inc, Yordan Karadzhov (VMware) <y.karadz@gmail.com>
+Copyright 2021 VMware Inc, Yordan Karadzhov (VMware) <y.karadz@gmail.com>
 """
 
 import os